import numpy as np
from DateTime import DateTime
progress_indicator = in_stream["Progress Indicator"]
in_data_stream = in_stream["Data Stream"]
out_data_array = out_array["Data Array"]
context.log(in_data_stream.getRelativeUrl())
context.log(out_data_array.getRelativeUrl())
start = progress_indicator.getIntOffsetIndex()
end = in_data_stream.getSize()


if start >= end:
  return

data = in_data_stream.getData().decode('utf8')
vt, vInititialEPSBEstabSR, vAddedEPSBEstabSR, evt, vIPThp_qci = context.Base_getORSKPIValue(data)

dtype = np.dtype([
  ('vt', 'float'),
  ('evt', 'float'),
  ('vInititialEPSBEstabSR_dl_lo', 'float64'),
  ('vInititialEPSBEstabSR_dl_hi', 'float64'),
  ('vAddedEPSBEstabSR_ul_lo', 'float64'),
  ('vAddedEPSBEstabSR_ul_hi', 'float64'),
])

tmp = []

for i in range(len(vt)):
  tmp.append((vt[i], 0, vInititialEPSBEstabSR[i][0], vInititialEPSBEstabSR[i][1], vAddedEPSBEstabSR[i][0], vAddedEPSBEstabSR[i][1]))

for i in range(len(evt)):
  for j in vIPThp_qci[i]:
    tmp.append((0, evt[i], j[0], j[1], j[2], j[3]))
ndarray =  np.ndarray((len(tmp), ), dtype, np.array(tmp))
zbigarray = out_data_array.initArray(shape=(0,), dtype=dtype)
zbigarray.append(ndarray)

progress_indicator.setIntOffsetIndex(end)

return
