import numpy as np

in_data_array = in_array["Data Array"]

in_zbigarray = in_data_array.getArray()
if in_zbigarray is None:
  return
if in_zbigarray.shape[0] == 0:
  return

for array in out_array:
  if array['variation'] == 'e_rab':
    e_rab_data_array = array['Data Array']
  if array['variation'] == 'e_utran':
    e_utran_data_array = array['Data Array']

if e_rab_data_array is None:
  return
if e_utran_data_array is None:
  return

e_rab_dtype = np.dtype([
  ('vt', 'float'),
  ('vInititialEPSBEstabSR_lo', 'float64'),
  ('vInititialEPSBEstabSR_hi', 'float64'),
  ('vAddedEPSBEstabSR_lo', 'float64'),
  ('vAddedEPSBEstabSR_hi', 'float64'),
])

e_utran_dtype =np.dtype([
  ('evt', 'float'),
  ('dl_lo', 'float64'),
  ('dl_hi', 'float64'),
  ('ul_lo', 'float64'),
  ('ul_hi', 'float64'),
])

e_rab_array = e_rab_data_array.getArray()
if not e_rab_array:
  e_rab_array = e_rab_data_array.initArray(shape=(0,), dtype=e_rab_dtype)
e_rab_array_data = []


e_utran_array = e_utran_data_array.getArray()
if not e_utran_array:
  e_utran_array = e_utran_data_array.initArray(shape=(0,), dtype=e_utran_dtype )
e_utran_array_data = []

progress_indicator = in_array["Progress Indicator"]

index = progress_indicator.getIntOffsetIndex()
max_len = len(in_zbigarray)

if index >= max_len:
  return

end = index + 50000

if end > max_len:
  end = max_len

for line in in_zbigarray[index: end]:
  if line['vt']:
    e_rab_array_data.append((line['vt'], line['vInititialEPSBEstabSR_dl_lo'], line['vInititialEPSBEstabSR_dl_hi'],  line['vAddedEPSBEstabSR_ul_lo'], line['vAddedEPSBEstabSR_ul_hi']))
  elif line['evt']:
    e_utran_array_data.append((line['evt'], line['vInititialEPSBEstabSR_dl_lo'], line['vInititialEPSBEstabSR_dl_hi'],  line['vAddedEPSBEstabSR_ul_lo'], line['vAddedEPSBEstabSR_ul_hi']))

if e_rab_array_data:
  e_rab_array_data =  np.ndarray((len(e_rab_array_data), ), e_rab_dtype, np.array(e_rab_array_data))
  e_rab_array.append(e_rab_array_data)
if e_utran_array_data:
  e_utran_array_data =  np.ndarray((len(e_utran_array_data), ), e_utran_dtype, np.array(e_utran_array_data))
  e_utran_array.append(e_utran_array_data)

progress_indicator.setIntOffsetIndex(end)
